from rocolib.api.components import Component

c = Component()

#Body of sides
c.addSubcomponent("side0", "Trapezoid")
for i in range(3):
    c.addSubcomponent("r%d" %i, "Rectangle")

c.addParameter("width", 147, paramType="length")
c.addParameter("length", 73, paramType="length")

c.addConstraint(("side0", "width"), "width")
c.addConstraint(("side0", "depth"), "width", "15")

c.addConstraint(("r0", "w"), "length")
c.addConstraint(("r0", "l"), "width")

for i in range(1,3):
    c.addConstraint(("r%d" %i, "w"), "length")
    c.addConstraint(("r%d" %i, "l"), "width", "float(15 * np.sqrt(2.))")

c.addConnection(("r0", "b"), ("side0", "topedge"), angle=-90)
c.addConnection(("side0", "redge"), ("r1", "t"), angle=-90)
c.addConnection(("side0", "ledge"), ("r2", "t"), angle=-90)

c.inheritInterface(("sideedge"), ("r0", "t"))
c.inheritInterface(("botedge"), ("side0", "botedge"))

c.toLibrary("Scooper")